<template>
	<div class="auth fill-height">
		<div class="layout align-center justify-center fill-height">
			<v-form
				class="auth-form"
				ref="form"
				v-model="valid"
				:lazy-validation="lazy"
			>
				<v-container fluid>
					<v-row>

						<v-col cols="12">
							<v-text-field
								v-model="email"
								:rules="emailRules"
								label="E-mail"
								required
								:error-messages="emailServerError"
								@input="onChangeInput"
							></v-text-field>
						</v-col>

						<v-col cols="12">
							<v-text-field
								v-model="password"
								:append-icon="show ? 'mdi-eye' : 'mdi-eye-off'"
								:rules="passwordRules"
								:type="show ? 'text' : 'password'"
								label="Пароль"
								@click:append="show = !show"
								@input="onChangeInput"
							></v-text-field>
						</v-col>

					</v-row>

					<v-btn
						:disabled="!valid"
						color="success"
						class="mr-4"
						@click="submit"
					>
						<v-icon left>mdi-login</v-icon> Войти
					</v-btn>

				</v-container>
			</v-form>
		</div>
	</div>
</template>

<script>
	import Request from '@/store/Request.js';

	export default {
		name: 'Auth',
		data: () => ({
			lazy: false,
			valid: false,
			show: false,
			password: '123123123',
			email: 'test@mail.ru',
			// password: '',
			// email: '',
			emailRules: [
				v => !!v || 'E-mail is required',
				v => /.+@.+/.test(v) || 'E-mail must be valid',
			],
			passwordRules: [
				v => !!v || 'Password is required',
			],
			emailServerError: '',
		}),
		methods: {
			async submit() {
				const url = 'https://api.vsebankety.ru/api/v1/user/login';
				const userData = {
					email: this.email,
					password: this.password,
					remember: 0,
				}
				const response = await Request.send(url, userData);
				if (response.data.success) {
					this.$store.dispatch('setUserData', response.data);
				} else {
					const errors = response.data.payload.messages
					for (const key in errors) {
						if (key === 'email') {
							this.$set(this, 'emailServerError', errors[key][0])
						}
					}
				}
			},
			onChangeInput() {
				this.$set(this, 'emailServerError', '')
			}
		},
	};
</script>


<style lang="stylus">
	// .auth
	// 	height 100%
	.auth-form
		width 300px
</style>